%define formats rom
# ne is only for backwards compat with older versions of qemu
%define qemuroms rtl8029 ne e1000-0x100e pcnet32 rtl8139 virtio-net

Distribution:   CCux
Packager:       Christian Metzen <metzench@ccux-linux.de>

Name:    	gpxe
Version: 	0.9.9
Release: 	1
BuildArch:	noarch
Summary: 	A network boot loader

Group:   	System/Base
License: 	GPLv2 and BSD
URL:     	http://etherboot.org/

Source0: 	http://git.etherboot.org/releases/%{name}/%{name}-%{version}.tar.bz2
Source1: 	USAGE
Patch0:  	gpxe-0.9.9-20091018.patch
Patch1:		gpxe-mkisofs.patch
BuildRequires: 	perl syslinux mtools mkisofs

%package 	bootimgs
Summary: 	Network boot loader images in bootable USB, CD, floppy and GRUB formats
Group:   	Development/Tools
BuildArch: 	noarch

%package 	roms
Summary: 	Network boot loader roms in .rom format
Group:  	Development/Tools
Requires: 	%{name}-roms-qemu = %{version}-%{release}
BuildArch: 	noarch

%package 	roms-qemu
Summary: 	Network boot loader roms supported by QEMU, .rom format
Group:  	Development/Tools
BuildArch: 	noarch


%description bootimgs
gPXE is an open source network bootloader. It provides a direct
replacement for proprietary PXE ROMs, with many extra features such as
DNS, HTTP, iSCSI, etc.

This package contains the gPXE boot images in USB, CD, floppy, and PXE
UNDI formats.

%description roms
gPXE is an open source network bootloader. It provides a direct
replacement for proprietary PXE ROMs, with many extra features such as
DNS, HTTP, iSCSI, etc.

This package contains the gPXE roms in .rom format.


%description roms-qemu
gPXE is an open source network bootloader. It provides a direct
replacement for proprietary PXE ROMs, with many extra features such as
DNS, HTTP, iSCSI, etc.

This package contains the gPXE ROMs for devices emulated by QEMU, in
.rom format.

%description
gPXE is an open source network bootloader. It provides a direct
replacement for proprietary PXE ROMs, with many extra features such as
DNS, HTTP, iSCSI, etc.

%prep
%setup -q
cp -a %{SOURCE1} .
%patch0 -p1
%patch1 -p1

%build
ISOLINUX_BIN=/usr/share/syslinux/isolinux.bin
cd src
make %{?_smp_mflags} ISOLINUX_BIN=${ISOLINUX_BIN}
make %{?_smp_mflags} bin/gpxe.lkrn
# The bnx2 firmware is too large to fit into an option ROM.
rm drivers/net/bnx2*.[ch]
make %{?_smp_mflags} allroms

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p %{buildroot}/%{_datadir}/%{name}/
pushd src/bin/

cp -a undionly.kpxe gpxe.{iso,usb,dsk,lkrn} %{buildroot}/%{_datadir}/%{name}/
#cp -a undionly.kpxe gpxe.{usb,dsk,lkrn} %{buildroot}/%{_datadir}/%{name}/

for fmt in %{formats};do
 for img in *.${fmt};do
      if [ -e $img ]; then
   cp -a $img %{buildroot}/%{_datadir}/%{name}/
   echo %{_datadir}/%{name}/$img >> ../../${fmt}.list
  fi   
 done
done
popd

# the roms supported by qemu will be packaged separatedly
# remove from the main rom list and add them to qemu.list
for fmt in rom ;do 
 for rom in %{qemuroms} ; do
  sed -i -e "/\/${rom}.${fmt}/d" ${fmt}.list
  echo %{_datadir}/%{name}/${rom}.${fmt} >> qemu.${fmt}.list
 done
done

%clean
rm -rf $RPM_BUILD_ROOT

%files bootimgs
%defattr(-,root,root,-)
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/gpxe.iso
%{_datadir}/%{name}/gpxe.usb
%{_datadir}/%{name}/gpxe.dsk
%{_datadir}/%{name}/gpxe.lkrn
%{_datadir}/%{name}/undionly.kpxe
%doc COPYING COPYRIGHTS USAGE

%files roms -f rom.list
%defattr(-,root,root,-)
%dir %{_datadir}/%{name}
%doc COPYING COPYRIGHTS

%files roms-qemu -f qemu.rom.list
%defattr(-,root,root,-)
%dir %{_datadir}/%{name}
%doc COPYING COPYRIGHTS

%changelog
* Sat Jan 23 2010 Christian Metzen <metzench@ccux-linux.de> 0.9.9-1
- Initial CCux package release
